import re

# get repub/dem docs
speech_keys = ('bill','speaker','party','mention','vote')
tag_re = re.compile('(\d+)_(\d+)_\d+_(\w)(\w)(\w)')
(rdocs, ddocs) = (set(), set())
D = 0
for (di, line) in enumerate(open('congress.doclist')):
    D += 1
    m = tag_re.match(line)
    if(m.group(3) == 'D'):
        ddocs.add(di)
    elif(m.group(3) == 'R'):
        rdocs.add(di)

# get tax(es) / worker(s) docs
vocab = [line.strip() for line in open('congress.vocab')]
print 'z-label to z=0'
print 'chairman = %d' % vocab.index('chairman')
print 'yield = %d' % vocab.index('yield')
print 'madam = %d' % vocab.index('madam')
print ''

# Get words/docs
(w,d) = ([], [])
for line in open('congress.docs'):
    d += [int(v) for v in line.split()]
for line in open('congress.words'):
    w += [int(v) for v in line.split()]

# Find docs containing tax(es) or worker(s)
taxesi = [vocab.index('tax'), vocab.index('taxes')]
workersi = [vocab.index('worker'), vocab.index('workers')]
(taxdocs, workdocs) = (set(), set())
for (wi, di) in zip(w, d):
    if(wi in taxesi):
        taxdocs.add(di)
    elif(wi in workersi):
        workdocs.add(di)

outf = open('congress.doclabel', 'w')
for di in range(D):
    if(di in workdocs and
       di in ddocs):
        outf.write('1\n')
    elif(di in taxdocs and
         di in rdocs):
        outf.write('2\n')        
    else:
        outf.write('0\n')        
outf.close()
       

