import pdb
import re
import cPickle as CP

afile = 'Ron-Annotation.txt'

# first line in each topic is just 'Topic N'
# ignore empty lines
alltopics = [[tw for tw in twords.split('\n')[1:]
              if len(tw) > 0]
             for twords in
             (''.join(open(afile))).split('\n\n')]

# List of (pos,neg) tuples for each topic
# pos = list of pos words
# neg = list of (word,explanation) tuples
#
annotation = []

# Extract with regex
#
are = re.compile('(\S+) = [0-9\.]+\s*(.*)')
for twords in alltopics:
    (pos,neg) = ([],[])
    for tw in twords:
        m = are.match(tw)
        (word,negexpl) = m.groups()
        if(len(negexpl) == 0):
            pos.append(word)
        else:
            neg.append((word,negexpl))
    annotation.append((pos,neg))

# Collect common failure modes
#
failures = {}
for (pos, neg) in annotation:
    for (word, explanation) in neg:
        failures.setdefault(explanation, []).append(word)

# Write out to files
#
outf = open('pos-labels.txt', 'w')
for (posi, pos) in enumerate([a[0] for a in annotation]):
    outf.write('Concept %d\n' % posi)
    for posword in pos:
        outf.write('%s\n' % posword)
    outf.write('\n')
outf.close()

outf = open('neg-labels.txt', 'w')
for (faili, (reason, failwords)) in enumerate(failures.items()):
    outf.write('Failure %d - %s\n' % (faili, reason))
    for failword in failwords:
        outf.write('%s\n' % failword)
    outf.write('\n')
outf.close()




