import numpy as NP
import os, os.path
import shutil
import sys
import re
from collections import deque
import random
import math

import pdb


# For each experiment, calc evaluation measues (with and without trainset incl)
#
tgtdir = 'hdg-folds'

# Final format will be ci-->logic-->types-->avg over k
results = [{} for ci in range(6)]

for ci in range(6):
    for logic in ['seed', 'incl', 'excl', 'all','lda']:
        results[ci][logic] = {}
        for ki in range(4):
            # Get results for each fold
            tgt = os.path.join(tgtdir, '%s-%d-%d' % (logic, ci, ki))
            for line in open(os.path.join(tgt, 'stewart.acc')):
                (vtype, val) = line.split()
                results[ci][logic].setdefault(vtype,[]).append(float(val))

def report(rtype, results):
    outf = open('%s.txt' % rtype, 'w')
    for ci in range(6):
        outf.write('Concept %d\n' % ci)
        for logic in ['seed', 'incl', 'excl', 'all','lda']:
            # Calculate mean and std dev for report 
            mu = NP.mean(NP.array(results[ci][logic][rtype]))
            sigma = NP.std(NP.array(results[ci][logic][rtype]))
            outf.write('\t%s = %.3f (+/- %.3f)\n' % (logic, mu, sigma))
        outf.write('\n')
    outf.close()

rtypes = ['Top50acc-all',
          'Top50acc-test',
          'MAP-all',
          'MAP-test']

for rtype in rtypes:
    report(rtype, results)


# methods = ['std', 'zl', 'excl', 'incl', 'all']
# legendm = ['LDA', 'SEED', 'EXCL', 'INCL', 'INCL+EXCL']
# colors = ['b','g--','r:','k--','m:']

# methods.reverse()
# legendm.reverse()
# colors.reverse()

# for topic in range(6):
#     P.figure()
#     P.xlabel('Recall', fontsize=25)
#     P.ylabel('Precision', fontsize=25)
#     for (m,c,mn) in zip(methods, colors, legendm):
#         prec = [float(line) for line in open('%s-%d.prec' % (m, topic))]
#         rec = [float(line) for line in open('%s-%d.rec' % (m, topic))]
#         P.plot(rec, prec, c, label=mn)
#     P.xlim((0.0,1.0))
#     P.ylim((0.0,1.0))
#     P.legend()
#     P.savefig('Topic-%d.png' % topic)
            
