import os, os.path
import shutil
import sys
import re
from collections import deque
import random
import math

import pdb

def prec(predicted, groundtruth):
    pred = set(predicted)
    tp = float(len(pred.intersection(groundtruth)))
    return tp / len(pred)

def meanAvgPrec(sortvals, groundtruth):
    precs = []
    for val in groundtruth:
        precs.append(prec(sortvals[:(sortvals.index(val)+1)], groundtruth))
    return sum(precs) / len(groundtruth)

# Read in all testset/trainset words
#
test = [[] for ci in range(6)]
train = [[] for ci in range(6)]
for ci in range(6):
    for ki in range(4):
        # REVERSE for 'seed expansion' test/train split
        train[ci].append([line.strip() for line in
                          open(os.path.join('folds','c%d-f%d.test' % (ci, ki)))])
        test[ci].append([line.strip() for line in
                         open(os.path.join('folds','c%d-f%d.train' % (ci, ki)))])

# For each experiment, calc evaluation measues (with and without trainset incl)
#
tgtdir = 'hdg-folds'

for ci in range(6):
    for ki in range(4):
        for logic in ['seed', 'incl', 'excl', 'all','lda']:
            tgt = os.path.join(tgtdir, '%s-%d-%d' % (logic, ci, ki))

            # Get sorted words for concept-topic
            words = [line.split()[0] for line in
                     open(os.path.join(tgt, 'stewart.concept'))]

            # ground truth relevant terms, w/ and w/o trainset
            groundall = set(test[ci][ki]).union(set(train[ci][ki]))
            groundtest = set(test[ci][ki])

            # concept-topic words, omitting trainset
            wordstest = [word for word in words if word not in train]

            outf = open(os.path.join(tgt, 'stewart.acc'), 'w')
            outf.write('Top50acc-all\t%f\n' % prec(words[:50], groundall))
            outf.write('Top50acc-test\t%f\n' % prec(wordstest[:50], groundtest))
            outf.write('MAP-all\t%f\n' % meanAvgPrec(words, groundall))
            outf.write('MAP-test\t%f\n' % meanAvgPrec(wordstest, groundtest))
            outf.close()


# methods = ['std', 'zl', 'excl', 'incl', 'all']
# legendm = ['LDA', 'SEED', 'EXCL', 'INCL', 'INCL+EXCL']
# colors = ['b','g--','r:','k--','m:']

# methods.reverse()
# legendm.reverse()
# colors.reverse()

# for topic in range(6):
#     P.figure()
#     P.xlabel('Recall', fontsize=25)
#     P.ylabel('Precision', fontsize=25)
#     for (m,c,mn) in zip(methods, colors, legendm):
#         prec = [float(line) for line in open('%s-%d.prec' % (m, topic))]
#         rec = [float(line) for line in open('%s-%d.rec' % (m, topic))]
#         P.plot(rec, prec, c, label=mn)
#     P.xlim((0.0,1.0))
#     P.ylim((0.0,1.0))
#     P.legend()
#     P.savefig('Topic-%d.png' % topic)
            
