import numpy as NP
import os, os.path
import shutil
import sys
import re
from collections import deque
import random
import math

import pdb

# Combine *.phi and *.vocab file to get a ranked list of
# words for the concept-topic in each experiment
#

# Read in the vocabulary
vocab = [line.strip() for line in open('stewart.vocab')]

# For standard LDA, we need to know the trainset word
# idx in order to select the best topic
#
# REVERSE train/test for 'seed expansion'
#
train = []
for ci in range(6):
    train.append([])
    for ki in range(4):               
        train[ci].append([vocab.index(line.strip()) for line in
                          open(os.path.join('folds','c%d-f%d.test' % (ci, ki)))])


tgtdir = 'hdg-folds'

for ci in range(6):
    for ki in range(4):
        for logic in ['seed', 'incl', 'excl', 'all', 'lda']:
            tgt = os.path.join(tgtdir, '%s-%d-%d' % (logic, ci, ki))

            phi = [[float(val) for val in line.split()] for line in
                   open(os.path.join(tgt, 'stewart.phi'))]

            if(logic != 'lda'):
                # we only care about concept-of-interest if LogicLDA
                phi = phi[ci]
            else:
                # in standard LDA, find the topic that maximizes the
                # probability mass assigned to trainset terms
                npphi = NP.array(phi)
                bestz = npphi[:, train[ci][ki]].sum(axis=1).argmax()
                phi = phi[bestz]
                
            wsorted = sorted(range(len(vocab)), key = lambda x: phi[x], reverse=True)

            # output sorted concept-of-interest
            outf = open(os.path.join(tgt, 'stewart.concept'), 'w')
            for wi in wsorted:
                outf.write('%s = %f\n' % (vocab[wi], phi[wi]))
            outf.close()
