import os, os.path
import shutil
import sys
import re
from collections import deque
import random
import math

import pdb

# development and disease seed words
devdis = "10000.000000-10.000000-seed-7993,1166,241,3717,5227-6\n"
devdis += "10000.000000-10.000000-seed-8881,7335,9689,8355,6349,10178,4073,7347-7\n"

# inclusion / exclusion templates
seedtemp = '100.0-10.0-seed-%s-%d\n'
incltemp = '10.0-100.0-sentincl-6-%d\n'
excltemp = '1.0-10.0-sentexcl-7-%d\n'

# Read in the vocabulary
vocab = [line.strip() for line in open('stewart.vocab')]

tgtdir = 'hdg-folds'

for ci in range(6):
    for ki in range(4):
        # !!!
        # REVERSE test/train for 'concept expansion' purposes
        # !!!
        test = [line.strip() for line
                in open(os.path.join('folds',
                                     'c%d-f%d.train' % (ci, ki)))]
        train = [line.strip() for line
                 in open(os.path.join('folds',
                                      'c%d-f%d.test' % (ci, ki)))]

        for logic in ['seed', 'incl', 'excl', 'all']:
            tgt = os.path.join(tgtdir, '%s-%d-%d' % (logic, ci, ki))

            outf = open(os.path.join(tgt, 'stewart.rules'), 'w')

            # always write out development / disease seed
            outf.write(devdis)

            # always write out trainset seed
            seedstr = ','.join([str(vocab.index(val)) for val in train])
            outf.write(seedtemp % (seedstr, ci))

            # incl
            if(logic == 'incl' or logic == 'all'):
                outf.write(incltemp % ci)

            # excl
            if(logic == 'excl' or logic == 'all'):
                outf.write(excltemp % ci)
            
            outf.close()
