import numpy as NP
import matplotlib.pyplot as P

methods = ['std', 'zl', 'excl', 'incl', 'all']
legendm = ['LDA', 'SEED', 'EXCL', 'INCL', 'INCL+EXCL']
colors = ['b','g--','r:','k--','m:']

methods.reverse()
legendm.reverse()
colors.reverse()

for topic in range(6):
    P.figure()
    P.xlabel('Recall', fontsize=25)
    P.ylabel('Precision', fontsize=25)
    for (m,c,mn) in zip(methods, colors, legendm):
        prec = [float(line) for line in open('%s-%d.prec' % (m, topic))]
        rec = [float(line) for line in open('%s-%d.rec' % (m, topic))]
        P.plot(rec, prec, c, label=mn)
    P.xlim((0.0,1.0))
    P.ylim((0.0,1.0))
    P.legend()
    P.savefig('Topic-%d.png' % topic)
