import sys
import numpy as NP

dsname = sys.argv[1]
N = int(sys.argv[2])

vocab = [line.rstrip() for line in open('%s.vocab' % dsname)]
W = len(vocab)

phifn = '%s.phi' % dsname
phi = []
for line in open(phifn):
    phi.append([float(val) for val in line.split()])
phi = NP.array(phi)
T = phi.shape[0]

outf = open('%s.topics' % dsname, 'w')
for ti in range(T):
    outf.write('\nTopic %d\n' % (ti,))
    top = range(W)
    top.sort(key=lambda wi:-phi[ti,wi])
    for wi in range(min(N,W)):
        outf.write('%s = %f\n' % (vocab[top[wi]], phi[ti,top[wi]]))
