import os, os.path

import nltk
import nltk.data
tokenizer = nltk.data.load('tokenizers/punkt/english.pickle')   

import GetVocab 



dsname = 'stewart'
#dsname = 'macvspc'
#docdir = '/ua/andrzeje/private/logicLDA/data/macvspc/'
docdir = '/ua/andrzeje/private/stewartConceptExpansion/data/tier2/text_files'
stoplist_fn = '/ua/andrzeje/private/logicLDA/data/ManningSchutzeAugmented.txt'

#doclist = os.listdir(docdir)
doclist = open('hdg-docs.txt').readlines()
D = len(doclist)

# First, get vocabulary
vocabthresh = 100
stopwords = [line.rstrip() for line in open(stoplist_fn)]
vocab = GetVocab.getVocab(docdir, doclist, vocabthresh, 
                          stopwords, '%s.vocab' % dsname)

(flatw, flatd, flats) = ([], [], [])


si = 0
for (di, doc) in enumerate(doclist):
    print 'doc %d of %d (%s)' % (di, D, doc)

    # Load actual doc
    #
    plaintxt = ' '.join([line.strip()
                         for line in 
                         open(os.path.join(docdir, doc))])   

    # Segment into sentences
    #
    sentences = tokenizer.tokenize(plaintxt)
    
    # Tokenize each sentence
    #
    tokenized_sentences = [nltk.word_tokenize(sent)
                           for sent in sentences]
    # Downcase everything
    #
    tokenized_sentences = [[w.lower() for w in sent]
                           for sent in tokenized_sentences]

    for sent in tokenized_sentences:
        for word in sent:
            if(word in vocab):
                # Only add words which are in vocab
                flatw.append(vocab.index(word))
                flatd.append(di)
                flats.append(si)
        if(flats[-1] == si):
            # Only inc sentence index if previous sentence was non-empty
            si += 1

outf = open('%s.words' % dsname, 'w')
outf.write(' '.join([str(wi) if (i % 1000 != 0) else '%d\n' % wi
                     for (i, wi) in enumerate(flatw)]))
outf.close()

outf = open('%s.docs' % dsname, 'w')
outf.write(' '.join([str(di) if (i % 1000 != 0) else '%d\n' % di
                     for (i, di) in enumerate(flatd)]))
outf.close()

outf = open('%s.sent' % dsname, 'w')
outf.write(' '.join([str(si) if (i % 1000 != 0) else '%d\n' % si
                     for (i, si) in enumerate(flats)]))
outf.close()


outf = open('%s.doclist' % dsname, 'w')
outf.write('\n'.join(doclist))
outf.close()




